The optional -m parameter allows specifying a commit message.
+=back
+
+Actions can be abbreviated to any unambiguous subsctring, so
+"mr st" is equivilant to "mr status".
+
=head1 OPTIONS
=over 4
=head1 FILES
-B<mr> is configured by .mrconfig files. It searches for .mrconfig files in
-your home directory, and in the root directory of each repository specified
-in a .mrconfig file. So you could have a ~/.mrconfig that registers a
+B<mr> is configured by .mrconfig files. It starts by reading the .mrconfig
+file in your home directory. Each repository specified in a .mrconfig file
+can also have its own .mrconfig file in its root directory that can
+optionally be used as well. So you could have a ~/.mrconfig that registers a
repository ~/src, that itself contains a ~/src/.mrconfig file, that in turn
registers several additional repositories.
There are two special parameters. If the "skip" parameter is set and
its command returns nonzero, then B<mr> will skip acting on that repository.
+If the "chain" parameter is set and its command returns nonzero, then B<mr>
+will try to load a .mrconfig file from the root of the repository. (You
+should avoid chaining from repositories with untrusted committers.)
The "default" section allows setting up default handlers for each action,
and is overridden by the contents of other sections. mr contains default
[src]
checkout = svn co svn://svn.example.com/src/trunk src
+ chain = true
[src/linux-2.6]
# only check this out on kodama
my $config="$ENV{HOME}/.mrconfig";
my $verbose=0;
my %config;
+my %knownactions;
Getopt::Long::Configure("no_permute");
my $result=GetOptions(
if (! $result || @ARGV < 1) {
die("Usage: mr [-d directory] action [params ...]\n");
}
-my $action=shift @ARGV;
loadconfig(\*DATA);
loadconfig($config);
#use Data::Dumper;
#print Dumper(\%config);
-my (@failures, @successes, @skipped);
+my $action=shift @ARGV;
+if (! $knownactions{$action}) {
+ my @matches = grep { /^\Q$action\E/ } keys %knownactions;
+ if (@matches == 1) {
+ $action=$matches[0];
+ }
+ else {
+ die "mr: ambiguous action \"$action\" (matches @matches)\n";
+ }
+}
+
+my (@failed, @successful, @skipped);
my $first=1;
foreach my $topdir (sort keys %config) {
foreach my $subdir (sort keys %{$config{$topdir}}) {
if (-d $dir) {
print "mr $action: $dir already exists, skipping checkout\n";
push @skipped, $dir;
- next;
+ return;
}
$dir=~s/^(.*)\/[^\/]+\/?$/$1/;
}
}
else {
print "mr $action: in $dir\n";
- my $command="set -e; my_action(){ $config{$topdir}{$subdir}{$action} ; }; my_action @ARGV";
+ my $command="set -e; my_action(){ $config{$topdir}{$subdir}{$action} ; }; my_action ".
+ join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
my $ret=system($command);
if ($ret != 0) {
print STDERR "mr $action: failed to run: $command\n" if $verbose;
- push @failures, $topdir.$subdir;
+ push @failed, $topdir.$subdir;
if ($ret >> 8 != 0) {
print STDERR "mr $action: command failed\n";
}
}
}
else {
- push @successes, $dir;
+ push @successful, $dir;
}
}
}
return;
}
print "\nmr $action: finished (".join("; ",
- showstat($#successes+1, "success", "successes"),
- showstat($#failures+1, "failure", "failures"),
+ showstat($#successful+1, "successful", "successful"),
+ showstat($#failed+1, "failed", "failed"),
showstat($#skipped+1, "skipped", "skipped"),
).")\n";
-exit @failures ? 1 : 0;
+if (@failed) {
+ exit 1;
+}
+elsif (! @successful && @skipped) {
+ exit 1;
+}
+exit 0;
my %loaded;
sub loadconfig {
next if /^\s*\#/ || /^\s*$/;
if (/^\s*\[([^\]]*)\]\s*$/) {
$section=$1;
- if (length $dir && $section ne "default" &&
- -e $dir.$section."/.mrconfig") {
- push @toload, $dir.$section."/.mrconfig";
- }
}
elsif (/^\s*(\w+)\s*=\s*(.*)/) {
my $parameter=$1;
$config{$dir}{$section}={ %{$config{$dir}{default}} };
}
$config{$dir}{$section}{$parameter}=$value;
+ $knownactions{$parameter}=1;
+
+ if ($parameter eq 'chain' &&
+ length $dir && $section ne "default" &&
+ -e $dir.$section."/.mrconfig" &&
+ system($value) >> 8 == 0) {
+ push @toload, $dir.$section."/.mrconfig";
+ }
}
else {
die "$f line $.: parse error\n";
}
}
-__DATA__
-# Some useful actions that mr knows about by default.
+# Finally, some useful actions that mr knows about by default.
# These can be overridden in ~/.mrconfig.
+__DATA__
[default]
update = \
if [ -d .svn ]; then \
elif [ -d .git ]; then \
git pull origin master; \
else \
- echo "mr update: unknown RCS"; \
+ echo "mr update: unknown repo type"; \
exit 1; \
fi
status = \
elif [ -d .git ]; then \
git status || true; \
else \
- echo "mr status: unknown RCS"; \
+ echo "mr status: unknown repo type"; \
exit 1; \
fi
commit = \
if [ -d .svn ]; then \
svn commit "$@"; \
elif [ -d .git ]; then \
- git commit -a "$@"; \
+ git commit -a "$@" && git push --all; \
else \
- echo "mr commit: unknown RCS"; \
+ echo "mr commit: unknown repo type"; \
exit 1; \
fi